/* RC Tamiya TA-02SW Battery Tray Brace
  (since the original doesn't allow standard sized stick-packs or other 2s hard case LiPos(nVision 4500mAh)....I wonder what Tamiya had in mind when designing this...
  
  Please don't judge me on the code below. It's a quick and dirty hack late at night (actually in the morning). TIA.
*/

include <../Modules/Module_Rounded_Cube.scad>;
include <../Modules/Write.scad_GitHub_2015-03-22/Write.scad>;
$fn=23;
//$fn=50;
gMS=2.4*2;
gLen=55;
gWid=15-5+4;
gHei=10;
gLenBrace=26+10+10-2*0-1;
gPostHei=6;
gPostDia=4.5;
gLowerCylDia=gPostDia;
//gLowerCylDia=8.0;
gLowerCylHei=2.0*0;
gRoundingDings=gLowerCylDia*1.5;

difference()
{
	union()
	{
		/* bottom plate */
		translate([0, gWid/2, gMS/2])
		roundedCubeWithCornerDiameter(gLen, gWid, gMS, gRoundingDings, gRoundingDings, gLowerCylDia, gLowerCylDia);

		/* brace */
		//translate([0, gMS/2, gHei/2])
		//cube([gLenBrace, gMS, gHei], center=true);
		if (0)
		translate([0, gMS/2, gHei/2])
		rotate([90, 0, 0])
		roundedCubeWithCornerDiameter(gLenBrace, gHei, gMS, 0, 0, 5, 5);
		
		/* post */
		flip=-1; // 1
		if (1)
//		for (xi=[-1, 1])
		for (xi=[-1])
		{
			translate([xi*(gLen/2-gLowerCylDia/2), gWid-gLowerCylDia/2, gMS])
			post();
		}

		if (1)
		translate([1*(gLen/2-gLowerCylDia/2)-1.25, gWid-gLowerCylDia/2-1-0.75, gMS])
		post();
	} // union
	
	/* Aussparung für Akku-Kabel */
	if (0)
	translate([0, 0, 23/2+gMS+gMS*2])
	rotate([90, 0, 0])
	roundedCubeWithCornerDiameter(gLenBrace-gMS*2*2, 23, 23, gLowerCylDia/2, gLowerCylDia/2, gLowerCylDia/2, gLowerCylDia/2);

	/* Aussparung für Akku */
	#translate([0-0.5, 10, gMS/2])
	roundedCubeWithCornerDiameter(gLenBrace, gHei, gMS, 3, 3, 3, 3);

	/* Loch für Scharnier-Schraube - UNFUG, bzw. Borschablone */
	if (0)
	#translate([gLenBrace/2+2, 10, 0])
	cylinder(d=2.6, h=23, center=true);

	/* Loch für Borschablone */
	if (0)
	#translate([-gLenBrace/2-3.25, 12, 0])
	cylinder(d=2.6, h=50, center=true);

	/* Label */
	if (0)
	translate([0+2, 12-4, 0])
	{
		rotate([0, 180, 0])
		{	
 			write("TA-02SW",h=5,font="../Modules/Write.scad_GitHub_2015-03-22/stencil_TNH.dxf",space=1.2, t=10, center=true);
		}
	}

} // difference

module post()
{
	difference()
	{
		du=4.5; // Durchmesser des obern Zylinders
		//echo(du);
		h=gPostHei;
		union()
		{
			/* Lower cyl */
			translate([0, 0, gLowerCylHei/2+gMS])
			cylinder(d=gLowerCylDia, h=gLowerCylHei, center=true);

			/* Upper Cyl */
			translate([0, 0, h/2])
			cylinder(d=du, h=h, center=true);
			
			/* Verrundung */
			translate([0, 0, h-0*du/2])
			sphere(d=du, center=true);
		}
	
		/* Bohrung für Splint */
		translate([0, 0, h-1*du/2+0.5])
		rotate([0, 90, 90])
		cylinder(d=2.0, h=23, center=true);
	}
}









